(function($) {
	// 校验网络 
	var network = true;
	mui.checkNetwork = function(){
		if(mui.os.plus){
			mui.plusReady(function () {
				if(plus.networkinfo.getCurrentType() == plus.networkinfo.CONNECTION_NONE){
					network = false;
				}else{
					network = true;
				}
				//监听网络状态变化事件
				document.addEventListener("netchange",onNetChange,false);
				//状态栏设置
				setstatus();
			}); 
		}
		return network;
	};
	
	function onNetChange() {  
		var nt = plus.networkinfo.getCurrentType();
		if(nt == plus.networkinfo.CONNECTION_NONE){
			network = false;
		}else{
			network = true;
		}
	};
	
	function setstatus(){
		if(plus.navigator.isFullscreen()){
			plus.navigator.setFullscreen(false);
		}
	};
	
	// 需要传递json 数据 请求调用接口
	mui.app_json_request= function (basePath,func_url,reqType,params,onSuccess,onError){
		if(mui.checkNetwork() == false){ 
			mui.toast("当前网络不给力，请稍后再试"); 
			return;
		}		
		var onSuccess = arguments[4]?arguments[4]:function(){};
		var onError = arguments[5]?arguments[5]:function(){};
		var func_url = basePath + func_url;
		mui.ajax(func_url,{  
			headers:{
				'token':mui.cacheUser.get(booking.constants.user_token),
				'secret':mui.cacheUser.get(booking.constants.user_secret),
				'serial':plus.device.uuid
			},
			data:params,
			timeout:60000,
			dataType:'json',//服务器返回json格式数据
			type:reqType,//HTTP请求类型
			contentType : 'application/json;charset=utf-8', //设置请求头信息
			success:function(data){ 
			    //获得服务器响应
			    if (data.success){
			    	onSuccess(data);
			    }else{
			    	if (data.code == -1){
						mui.cacheUser.clearCachePages(true); 
						mui.cacheUser.clear();
			    		mui.toast("认证失败，请重新登录！");    
			    		mui.openWindow(mui.app_filePath("template/login/login.html"),"login");
						return;
			    	}
			    	onError(data);
			    }
			},
			error: function(XMLHttpRequest, textStatus, errorThrown){ 
				if(network==false){
					mui.toast("当前网络不给力，请稍后再试"); 
					return;
				}
				mui.toast("当前网络不给力，请稍后再试");  
			}
		});
	}
	
	
	// 需要认证用户身份的请求调用接口
	mui.app_request= function (basePath,func_url,reqType,params,onSuccess,onError){
		if(mui.checkNetwork() == false){ 
			mui.toast("当前网络不给力，请稍后再试"); 
			return;
		}		
		var onSuccess = arguments[4]?arguments[4]:function(){};
		var onError = arguments[5]?arguments[5]:function(){};
		var func_url = basePath + func_url;
		mui.ajax(func_url,{  
			headers:{
				'token':mui.cacheUser.get(booking.constants.user_token),
				'secret':mui.cacheUser.get(booking.constants.user_secret),
				'serial':plus.device.uuid
			},
			data:params,
			timeout:60000,
			dataType:'json',//服务器返回json格式数据
			type:reqType,//HTTP请求类型
			success:function(data){ 
			    //获得服务器响应
			    if (data.success){
			    	onSuccess(data);
			    }else{
			    	if (data.code == -1){
						mui.cacheUser.clearCachePages(true); 
						mui.cacheUser.clear();
			    		mui.toast("认证失败，请重新登录！");    
			    		mui.openWindow(mui.app_filePath("template/login/login.html"),"login");
						return;
			    	}
			    	onError(data);
			    }
			},
			error: function(XMLHttpRequest, textStatus, errorThrown){ 
				if(network==false){
					mui.toast("当前网络不给力，请稍后再试"); 
					return;
				}
				mui.toast("当前网络不给力，请稍后再试");  
			}
		});
	}
	
	//用户信息管理
	mui.cacheUser = { 
		/**
		 * 清除用户缓存信息
		 */
		clear:function(){
			plus.storage.removeItem(booking.constants.user_token);
      		plus.storage.removeItem(booking.constants.user_secret);   
      		plus.storage.removeItem(booking.constants.user_mobile);
      		plus.storage.removeItem(booking.constants.book_date_key);
      		plus.storage.removeItem(booking.constants.queue_date_key);
      		plus.storage.removeItem(booking.constants.record_book_date_key);
      		plus.storage.removeItem(booking.constants.record_queue_date_key);
      		plus.storage.removeItem(booking.constants.bq_now_date_key);
		},
		clearMap:function(valueKey){
			plus.storage.removeItem(valueKey);
		},
		save:function(token,secret,mobile){
			plus.storage.setItem(booking.constants.user_token,token);
      		plus.storage.setItem(booking.constants.user_secret,secret); 
      		plus.storage.setItem(booking.constants.user_mobile,mobile);
		},
		saveMap:function(valueKey,value){
			plus.storage.setItem(valueKey,value);
		},
		get:function(key){
			return plus.storage.getItem(key);
		},
		isLogin:function(){
			var user_token = plus.storage.getItem(booking.constants.user_token);
			var user_secret = plus.storage.getItem(booking.constants.user_secret);  
			if(mui.isnull(user_token) || mui.isnull(user_secret)){  
				return false;
			}
			return true;
		},
		/**
		 * 清除当前页面以外的其他页面
		 */
		clearCachePages:function(holdPage){
			// 清除所有缓存页面
      		var cachepages = plus.webview.all();
      		var curr = plus.webview.currentWebview();
      		if (holdPage){
      			mui.each(cachepages,function(index,item){
	      			// 不是当前页和首页的都可以删除
	      			if (item.getURL().indexOf('start.html') < 0){
	      				plus.webview.close(item);
	      			}
      			});
      			return;
      		}
      		mui.each(cachepages,function(index,item){
      			// 不是当前页和首页的都可以删除
      			if (item.getURL() != curr.getURL() && item.getURL().indexOf('start.html') < 0){
      				plus.webview.close(item);
      			}
      		});
		}
	}
	
	//校验非空,true为空；false不空
	mui.isnull = function(data){
		if(typeof(data) == 'string'){
			data = data.trim();
		}
		return data == null || data == 'null' || data == "" || typeof(data) == "undefined" || data.length == 0 ? true : false;
	}
	
	//呼叫弹出框
    mui.dialService = function(hintMsg,mobile,format_mobile){
		plus.nativeUI.confirm(hintMsg,function(e){
			if(e.index==1){
				plus.device.dial(mobile,false);
			}
		},
		format_mobile,["取消","呼叫"]);
    }

    /**
     * 打开新页面 
     * @param {Object} page_url页面路径
     * @param {Object} pageid 页面id
     */
	mui.openNewPage = function(page_url,pageid){
		//判断token和密钥是否存在，不存在则转到登录页面。
		if(!mui.cacheUser.isLogin()){  
			mui.openWindow(mui.app_filePath("template/login/login.html"));
			return;
		}
		mui.openWindow(
				page_url,
				pageid,
				{waiting:{ 
      				autoShow:true,//自动显示等待框，默认为true
      				title:'正在加载...',//等待对话框上显示的提示内容
				}}
		);
	}
	
	/**
	 * 放回指定页面，并且刷新指定页面
	 * @param {Object} pageId 指定页面ID
	 * @param {Object} isRefresh  是否刷新  如：true=刷新；false=不刷新
	 */
	mui.app_back = function(pageId,isRefresh){
		mui.init({
			beforeback:function(){
				if(!mui.isnull(pageId)){
					var _page = plus.webview.getWebviewById(pageId);
					
					if(_page){
						_page.reload(isRefresh);	
					}
				}
				return true;
			}
    	});
    	mui.back(); 
	} 
	
	/**
	 * 放回指定页面，并且刷新指定页面
	 * @param {Object} pageId 指定页面ID
	 */
	mui.app_refresh = function(pageId){
		if(!mui.isnull(pageId)){
			var _page = plus.webview.getWebviewById(pageId); 
			if(_page){
				_page.reload(true);
			}
		}	 
	}
	
	/**
	 * 获取文件所在环境具体位置 
	 * @param {Object} file_url 文件及文件所在位置    如：booking/login/login.html
	 */
	mui.app_filePath = function(file_url){
		var path=plus.io.convertLocalFileSystemURL('_www/'+file_url);
		var filePath = plus.io.convertAbsoluteFileSystem(path);
		return filePath;
	}
	
})(mui); 

/**
 * 自定义工具类
 */
var booking = {
	// 系统常量
	constants:{
		//接口域名地址
		//api_domain:"http://192.168.3.200:8080/",
	  	api_domain:"http://api.yuyueking.com:998/",
		//token
		user_token:'user_token',
		//预约日期缓存Key
		book_date_key:'book_date_key',
		//排队日期缓存Key
		queue_date_key:'queue_date_key',
		//预约记录日期缓存Key
		record_book_date_key:'record_book_date_key',
		//排队记录日期缓存Key
		record_queue_date_key:'record_queue_date_key',
		//预约、排队当前日期key
		bq_now_date_key:'bq_now_date_key',
		//密钥
		user_secret:'user_secret',
		//用户手机号
		user_mobile:'user_mobile',
		reqPost:'POST',
		reqGet:'GET',
		sms_Timeout:60,
		upload_server:"http://upload.yuyueking.com:888/" 
		//upload_server:"http://192.168.3.200:888/" 
		
	},
	/**
	 * 验证手机号是否符合格式要求 
	 * @param {Object} mobile
	 */
	validate_mobile:function (mobile){
		var mobilePattern=/^(((13[0-9])|(14[0-9])|(15[0-9])|(17[0-9])|(18[0-9]))+\d{8})$/;//手机校验规则
		if(!mobilePattern.test(mobile)){
    			return false;
    	}
		return true;
	},
	
	/**
	 * 验证密码是否符合格式要求
	 * @param {Object} password
	 */
	validate_password:function(password){
		var passwordPattern=/^[0-9A-Za-z]{6,16}$/;//登录密码校验规则
		if(!passwordPattern.test(password)){
			return false;
		}
		return true;
	},
	dateUtil:{
		/**
		*转换日期对象为日期字符串
		* @param l long值
		* @param pattern 格式字符串,例如：yyyy-MM-dd hh:mm:ss
		* @return 符合要求的日期字符串
		*/
		getFormatDate:function(curDate, pattern) {
			if (mui.isnull(curDate)) {
				curDate = new Date();
			}
			if (mui.isnull(pattern)) {
				pattern = "yyyy-MM-dd";
			}
			return curDate.format(pattern);
		},
		/**
		 * 将long 值转换为对应的日期格式值
		 * @param {Object} longdate
		 * @param {Object} pattern
		 */
		getFormatDataByLong:function(longdate, pattern){
			if (mui.isnull(longdate)){
				return;
			}
			if (mui.isnull(pattern)) {
				pattern = "yyyy-MM-dd";
			}
			return booking.dateUtil.getFormatDate(new Date(longdate*1000),pattern);
		}
	},
	init:{
		initHearListener:function(){
			if (document.getElementById("telBtn")){
				document.getElementById("telBtn").addEventListener("tap",function(){
	    			mui.dialService("工作日 8:30-24:00  周末 9:00-17:00","4000200158","400-020-0158");
	    		});
    		}
    		if (document.getElementById("back")){
    			document.getElementById("back").addEventListener("tap",function(){
    				mui.back();
    			});
    		}
		}
	}
}

/**
 * 短信倒计时 60s
 * @param {Object} o  点击获取验证码对象
 */
booking.time = 60;
booking.smsTime = function(o){
    if (booking.time == 0) {  
        o.removeAttribute("disabled");            
        o.innerHTML="发送验证码";  
        booking.time = 60;  
    } else {  
        o.setAttribute("disabled", true);  
        o.innerHTML="倒计时(" + booking.time + ")";  
        booking.time--;  
        setTimeout(function() {  
            booking.smsTime(o);   
        },  
        1000)  
    } 
}

/**
 * 短信倒计时 60s
 * @param {Object} o  点击获取验证码对象
 */
booking.time_new = 60;
booking.smsTime_new=function(o){
    if (booking.time_new == 0) {  
        o.removeAttribute("disabled");            
        o.innerHTML="发送验证码";  
        booking.time_new = 60;
    } else {  
        o.setAttribute("disabled", true);  
        o.innerHTML="倒计时(" + booking.time_new + ")";   
        booking.time_new--;  
       setTimeout(function() {  
            booking.smsTime_new(o);  
        },  
        1000)  
    } 
}

/**
 * 校验用户是否录入资料
 */
booking.valaidate_input_info = function(indexPath,inputPath){
	mui.app_request(booking.constants.api_domain,'/user/sm_setting/needUpdate','GET',{			  
		},function(result){
			mui.openWindow(indexPath,'index');
				return;
		},function(result){
			if(result.code =="0"){
				mui.openWindow(inputPath,'basic_business');
				return;
			}
			else
			{
				mui.openWindow(indexPath,'index');
				return;
			}
	});
}

/**
 * 刷新初始化页面
 */
booking.refresh_init_page = function(){
	mui.app_refresh('account_main');    
	mui.app_refresh('book'); 
	mui.app_refresh('queue'); 
	mui.app_refresh('manageSwiths'); 
	mui.app_refresh('manageAudit'); 
}

/**
 * 校验页面是否打开，打开就直接显示
 * @param {Object} path
 * @param {Object} id
 */
booking.showWindow = function (pagePath,pageId){
	var _page = plus.webview.getWebviewById(pageId); 
	if(_page){
		plus.webview.show(pageId);
		return;
	}		
	mui.openWindow(pagePath,pageId);
}

/**
 * 行业数据
 * 1.餐饮、2.酒店住宿、3.运动健身、4.生活服务、5.休闲娱乐、6.医疗卫生、7.汽车保养、8.教育培训、9.其他；
 */
booking.industry_array = [{
				value: 1,
				text: '餐饮'
			}, {
				value: 2,
				text: '酒店住宿'
			}, {
				value: 3,
				text: '运动健身'
			}, {
				value: 4,
				text: '生活服务'
			}, {
				value: 5,
				text: '休闲娱乐'
			}, {
				value: 6,
				text: '医疗卫生'
			}, {
				value: 7,
				text: '汽车保养'
			}, {
				value: 8,
				text: '教育培训'
			}, {
				value: 9,
				text: '其他'
			}];